org.apache.bcel.generic

## Class TABLESWITCH

- java.lang.Object
- - org.apache.bcel.generic.Instruction
  - - org.apache.bcel.generic.BranchInstruction
    - - org.apache.bcel.generic.Select
      - - org.apache.bcel.generic.TABLESWITCH

- All Implemented Interfaces:
    Cloneable, InstructionTargeter, StackConsumer, StackProducer, VariableLengthInstruction

      public class TABLESWITCH
      extends Select

  TABLESWITCH - Switch within given range of values, i.e., low..high
  Version:
    $Id: TABLESWITCH.java 1812166 2017-10-13 23:48:11Z ggregory $
  See Also:
    `SWITCH`

- - ### Field Summary

    - ### Fields inherited from class org.apache.bcel.generic.Select

      `fixed_length, indices, match, match_length, padding, targets`

    - ### Fields inherited from class org.apache.bcel.generic.BranchInstruction

      `index, position, target`

    - ### Fields inherited from class org.apache.bcel.generic.Instruction

      `length, opcode`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TABLESWITCH(int[] match, InstructionHandle[] targets, InstructionHandle defaultTarget)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept(Visitor v)` Call corresponding visitor method(s).
    `void` | `dump(DataOutputStream out)` Dump instruction as byte code to stream out.
    `protected void` | `initFromFile(ByteSequence bytes, boolean wide)` Read needed data (e.g.

    - ### Methods inherited from class org.apache.bcel.generic.Select

      `clone, containsTarget, getIndices, getMatchs, getTargets, setTarget, toString, updatePosition, updateTarget`

    - ### Methods inherited from class org.apache.bcel.generic.BranchInstruction

      `getIndex, getPosition, getTarget, getTargetOffset, getTargetOffset, setIndex, setPosition, setTarget`

    - ### Methods inherited from class org.apache.bcel.generic.Instruction

      `consumeStack, copy, equals, getComparator, getLength, getName, getOpcode, hashCode, isValidByte, isValidShort, produceStack, readInstruction, setComparator, toString, toString`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.bcel.generic.StackConsumer

      `consumeStack`

    - ### Methods inherited from interface org.apache.bcel.generic.StackProducer

      `produceStack`

- - ### Constructor Detail

    - #### TABLESWITCH

          public TABLESWITCH(int[] match,
                             InstructionHandle[] targets,
                             InstructionHandle defaultTarget)

      Parameters:
        `match` - sorted array of match values, match[0] must be low value, match[match_length - 1] high value
        `targets` - where to branch for matched values
        `defaultTarget` - default branch

  - ### Method Detail

    - #### dump

          public void dump(DataOutputStream out)
                    throws IOException

      Dump instruction as byte code to stream out.
      Overrides:
        `dump` in class `Select`
      Parameters:
        `out` - Output stream
      Throws:
        `IOException`

    - #### initFromFile

          protected void initFromFile(ByteSequence bytes,
                                      boolean wide)
                               throws IOException

      Read needed data (e.g. index) from file.
      Overrides:
        `initFromFile` in class `Select`
      Parameters:
        `bytes` - input stream
        `wide` - wide prefix?
      Throws:
        `IOException` - may be thrown if the implementation needs to read data from the file
      See Also:
        `InstructionList`

    - #### accept

          public void accept(Visitor v)

      Call corresponding visitor method(s). The order is: Call visitor methods of implemented interfaces first, then call methods according to the class hierarchy in descending order, i.e., the most specific visitXXX() call comes last.
      Specified by:
        `accept` in class `Instruction`
      Parameters:
        `v` - Visitor object

Copyright © 2004–2019 The Apache Software Foundation. All rights reserved.